(function() {
  var Stack, checkDefined, checkState, debug, _ref;

  debug = require('debug')('lifo');

  _ref = require('conditional'), checkDefined = _ref.checkDefined, checkState = _ref.checkState;

  Stack = (function() {
    function Stack() {
      this.stack = [];
    }

    Stack.prototype.size = function() {
      return this.stack.length;
    };

    Stack.prototype.isEmpty = function() {
      return this.size() === 0;
    };

    Stack.prototype.peek = function() {
      return this.stack[this.stack.length - 1];
    };

    Stack.prototype.pop = function() {
      var element;
      checkState(!this.isEmpty(), 'stack is empty');
      element = this.peek();
      this.stack = this.stack.slice(0, this.stack.length - 1);
      debug("poped: " + element);
      return element;
    };

    Stack.prototype.push = function(element) {
      checkDefined(element, 'cannot put undefined values in stack');
      this.stack.push(element);
      debug("pushed: " + element);
      return this.size();
    };

    return Stack;

  })();

  module.exports = function() {
    return new Stack;
  };

}).call(this);
